﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Data.Entity;
using System.ComponentModel.DataAnnotations.Schema;//必须引入entityframework.dll

namespace EFTest1
{
    public class VetContext : DbContext
    {
        public VetContext(string contstr):base(contstr)
        {
        }
        public DbSet<Patient> Patients { get; set; }
        public DbSet<Visit> Visits { get; set; }

    }
    public class Patient
    {

        public Patient()
        {

            Visits = new List<Visit>();

        }
        
        public int Id { get; set; }
       [MaxLength(100)]
        public string Name { get; set; }
        
        public DateTime BirthDate { get; set; }

        [ForeignKey("Id")]
        public AnimalType AnimalType { get; set; }

        public DateTime FirstVisit { get; set; }
        [ForeignKey("PatientId")]
        public List<Visit> Visits { get; set; }

    }

    public class Visit
    {
        [Key]
        public int Id { get; set; }

        public DateTime Date { get; set; }

        public String ReasonForVisit { get; set; }

        public String Outcome { get; set; }

        public Decimal Weight { get; set; }

       
        public int PatientId { get; set; }

    }


    [Table("aa")]
    public class AnimalType
    {
        [Key]
        public int Id { get; set; }
        [Required]
        [MaxLength(200)]
        public string TypeName { get; set; }

    }
   public  class Program
    {
        private static void CreateNewPatient()
        {

            var dog = new AnimalType { TypeName = "Dog" };

            var patient = new Patient

            {

                Name = "Sampson",

                BirthDate = new DateTime(2008, 1, 28),
                FirstVisit = new DateTime(2011,1,1),


                AnimalType = dog,

                Visits = new List<Visit>{
new Visit{Date = new DateTime(2011, 9, 1)}
}

            };

            using (var context = new VetContext("Data Source=localhost;Initial Catalog=EFTest;Integrated Security=False;Persist Security Info=False;User ID=sa;Password=aa;MultipleActiveResultSets=True"))
            {

                context.Patients.Add(patient);
                context.SaveChanges();

            }

        }
        static void Main(string[] args)
        {
            CreateNewPatient();
        }
    }
}
